Theming and Styling in Angular PDF Viewer

24 Aug 20265 minutes to read

The Angular PDF Viewer supports multiple built-in themes and flexible styling options to match your application’s UI design.

Supported Themes

The PDF Viewer styles the toolbar, buttons, panels, annotations, and dialogs based on the selected theme. The available built-in Syncfusion themes are:

  • Material 3
  • Fluent 2
  • Bootstrap 5
  • Tailwind

How-to: Quick Start

Step 1: Create an Angular PDF Viewer application by following the Angular PDF Viewer getting started guide.

Step 2: Install the Tailwind 3 theme package and import its CSS in angular.json or styles.css. The index.css file automatically includes all required dependent component styles for the PDF Viewer.

npm install @syncfusion/ej2-tailwind3-theme
@import '../node_modules/@syncfusion/ej2-tailwind3-theme/styles/pdfviewer/index.css';

Tutorial

  1. Create a new Angular app and install the Syncfusion PDF Viewer package.
  2. Add the required theme imports to the global styles file.
  3. Render the PDF Viewer in your application component.
  4. Add a theme switcher for light and dark modes.
  5. Apply scoped custom styles using a wrapper class.

Theming for Dark Mode

Dark themes provide a better viewing experience in low-light environments. The Angular PDF Viewer supports:

  • Material 3 Dark
  • Bootstrap 5 Dark
  • Fluent 2 Dark
  • Tailwind Dark
  • Fluent 2 High Contrast

Update the viewer container background color when switching to dark theme for visual consistency.

Toggle Dark Mode

You can dynamically change the theme by swapping the linked stylesheet.

import { Component, OnInit } from '@angular/core';
import {
  PdfViewerModule, LinkAnnotationService, BookmarkViewService, 
  MagnificationService, ThumbnailViewService, ToolbarService,
  NavigationService, TextSearchService, TextSelectionService, 
  PrintService, PageOrganizerService, AnnotationService,
  FormDesignerService, FormFieldsService,
} from '@syncfusion/ej2-angular-pdfviewer';

type ThemeName = 'material3' | 'material3-dark';
const THEME_LINK_ID = 'e-current-theme';

@Component({
  selector: 'app-container',
  standalone: true,
  imports: [PdfViewerModule],
  providers: [
    LinkAnnotationService, BookmarkViewService, MagnificationService,
    ThumbnailViewService, ToolbarService, NavigationService,
    AnnotationService, TextSearchService, TextSelectionService,
    PrintService, FormDesignerService, FormFieldsService,
    PageOrganizerService,
  ],
  template: `
    <!-- Theme Switcher -->
    <div style="margin-bottom:10px; display:flex; gap:8px; align-items:center">
      <label for="themeSelect"><strong>Theme:</strong></label>
      <select id="themeSelect" [value]="theme" (change)="onThemeChange($event)">
        <option value="material3">Material 3 (Light)</option>
        <option value="material3-dark">Material 3 Dark</option>
      </select>
    </div>

    <!-- PDF Viewer -->
    <div class="content-wrapper e-custom-style">
      <ejs-pdfviewer
        id="pdfViewer"
        [documentPath]="document"
        [resourceUrl]="resource"
        style="height:640px;display:block">
      </ejs-pdfviewer>
    </div>
  `,
})
export class AppComponent implements OnInit {
  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';

  public resource =
    'https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2-pdfviewer-lib';

  public theme: ThemeName = 'material3';

  ngOnInit(): void {
    this.applyTheme(this.theme);
  }

  onThemeChange(event: Event): void {
    const value = (event.target as HTMLSelectElement).value as ThemeName;
    this.theme = value;
    this.applyTheme(this.theme);
  }

  private applyTheme(theme: ThemeName): void {
    const themeUrl = `https://cdn.syncfusion.com/ej2/33.1.44/${theme}.css`;

    let themeLink = document.getElementById(THEME_LINK_ID) as HTMLLinkElement;

    if (!themeLink) {
      themeLink = document.createElement('link');
      themeLink.id = THEME_LINK_ID;
      themeLink.rel = 'stylesheet';
      document.head.prepend(themeLink);
    }

    themeLink.href = themeUrl;
  }
}

Custom Styles

Built-in themes cover common needs, but you can safely apply your own overrides using scoped styles.

Guidelines

  • Load Order: Always load the Syncfusion default theme CSS before applying any custom overrides.
  • Custom Classes: Prefer using .e-custom-style classes for overrides to ensure your styles are applied correctly without conflicting with internal logic.
  • Avoid Deep Overrides: Do not override internal classes deeply, as this may break the component’s layout or responsiveness in future updates.

Example: Scoped Custom Styles

.e-custom-style .e-pv-page-container {
  background: #0b1220;
}

.e-custom-style .e-pdfviewer-signatureformfields,
.e-custom-style .e-pdfviewer-signatureformfields-signature {
  border: 1px solid #b3d1ff;
  border-radius: 5px;
}
<div class="control-section e-custom-style">
  <ejs-pdfviewer
    [resourceUrl]="resource"
    [documentPath]="documentPath"
    style="height:640px">
  </ejs-pdfviewer>
</div>

Explanation

This section explains the rationale behind the recommendations and common pitfalls:

  • Use a scoped wrapper class (for example .e-custom-style) to avoid fragile, global overrides that can break when internal selectors change.
  • Load order is important: theme CSS provides base variables and components’ base rules; custom overrides must load after theme CSS to take effect reliably.
  • Prefer toggling theme files or a small root class rather than deep selector overrides when implementing dark mode — this makes switching simpler and reduces maintenance.
  • Avoid overusing !important; reserve it for third-party widgets or unavoidable form-field styling where the library applies strong specificity.
  • Always verify color-contrast and keyboard focus styles after applying themes or overrides to preserve accessibility.

Reference

Theming and Styling in React PDF Viewer

25 Aug 202610 minutes to read

The React PDF Viewer supports a wide range of built-in themes and flexible UI customization to match your application’s design.

Supported Themes

The PDF Viewer applies styles to the toolbar, buttons, panels, annotations, and dialogs based on the selected theme. The available built-in Syncfusion themes are:

  • Material 3
  • Fluent 2
  • Bootstrap 5
  • Tailwind

How-to: Quick start

Step-1: Create a PDF Viewer sample by following the React PDF Viewer getting started guide.

Step-2: To change the theme to tailwind, install the Tailwind 3 theme package and add its import to app.css. The index.css file automatically includes all required dependent component styles for the PDF Viewer.

npm install @syncfusion/ej2-tailwind3-theme
@import '../node_modules/@syncfusion/ej2-tailwind3-theme/styles/pdfviewer/index.css';

Tutorial

This short, guided walkthrough shows a minimal end-to-end customization flow:

  1. Create a new React app and install the viewer.

  2. Add the Tailwind theme import to your global CSS (see Quick start).

  3. Render the PDF Viewer in src/App and verify the default look.

  4. Add a theme switcher using the dark-mode logic shown later in this file

  5. Add additional CSS rules under .e-custom-style and load it after the theme CSS, and verify appearance and accessibility.

Theming for Dark Mode

To provide a better viewing experience in low-light environments, you can apply dark themes or allow users to switch between light and dark modes.

Apply Dark Theme

You can initialize the PDF Viewer with a dark theme by referencing the corresponding CSS:

  • Material 3 Dark
  • Bootstrap 5 Dark
  • Fluent 2 Dark
  • Tailwind Dark
  • Fluent 2 High Contrast

Switch between Light and Dark Mode

You can dynamically change the theme in your application to toggle between light and dark modes.

Ensure the background color of the PDF container is also updated to a dark shade when switching to a dark theme to maintain visual consistency.

How-to: Toggle Dark Mode

Below is an approach that can be copied into the app that switches themes by dynamically changing the link referenced in the style sheet in the head section of the document.

Link-swap approach:

type ThemeName = 'material3' | 'material3-dark';
const THEME_LINK_ID = 'e-current-theme';
function applyTheme(theme: ThemeName) {
    const path = `https://cdn.syncfusion.com/ej2/32.2.5/${theme}.css`;
    let primaryThemeLink = document.querySelector(`#${THEME_LINK_ID}`) as HTMLLinkElement;
    if (!primaryThemeLink) {
        primaryThemeLink = document.createElement('link');
        primaryThemeLink.id = THEME_LINK_ID;
        primaryThemeLink.rel = 'stylesheet';
        document.head.prepend(primaryThemeLink);
    }
    primaryThemeLink.href = path;
}
export function App() {
    const [theme, setTheme] = useState<ThemeName>('material3');
    useEffect(() => {
        applyTheme(theme);
    }, [theme]);
    // Simple memoized list for selector
    const options = useMemo(
        () => [
            { value: 'material3', label: 'Material 3 (Light)' },
            { value: 'material3-dark', label: 'Material 3 Dark' },
        ],
        []
    );
    return (<div>
        <label style={{ display: 'inline-flex', gap: 8, alignItems: 'center' }}>
            Theme:
            <select value={theme} onChange={(e) => setTheme(e.target.value as ThemeName)}>
                {options.map(o => (
                    <option key={o.value} value={o.value}>{o.label}</option>
                ))}
            </select>
        </label>
        <div className='control-section e-custom-style'>
            <PdfViewerComponent
                id="container"
                documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                resourceUrl="https://cdn.syncfusion.com/ej2/32.2.5/dist/ej2-pdfviewer-lib"
                style={{ 'height': '640px' }}>

                <Inject services={[Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner, PageOrganizer]} />
            </PdfViewerComponent>
        </div>
    </div>);
}

Custom Styles

While built-in themes provide a comprehensive look and feel, you might need to apply specific style overrides for your application.

Implementation Guidelines

  • Load Order: Always load the Syncfusion default theme CSS before applying any custom overrides.
  • Custom Classes: Prefer using .e-custom-style classes for overrides to ensure your styles are applied correctly without conflicting with internal logic.
  • Avoid Deep Overrides: Do not override internal classes deeply, as this may break the component’s layout or responsiveness in future updates.

How-to: Apply Custom Styles

Apply overrides using a wrapper class so the rules are scoped and safe to maintain. The following example adds custom styles to signature form fields:

/* This rule sets a scoped, custom black background for the PDF viewer page container */
.e-custom-style .e-pv-page-container {
        background: #0b1220;
}

/* The following rules style the signature form fields with blue background. See screenshot below for more clarity */
.e-custom-style .e-pdfviewer-signatureformfields,
.e-custom-style .e-pdfviewer-signatureformfields-signature {
    border: 1px solid #b3d1ff !important;
    border-radius: 5px;
}
.e-custom-style span[id^='signIcon'] {
    background-color: #e6f2ff !important;
    border: 1px solid #b3d1ff !important;
    border-radius: 4px !important;
    font-weight: bold !important;
    color: #003366 !important;
    display: inline-block !important;
    height: 100% !important;
    text-align: center !important;
}
.e-custom-style span[id^='initialIcon'] {
    background-color: #e6f2ff !important;
    border: 1px solid #b3d1ff !important;
    border-radius: 4px !important;
    font-weight: bold !important;
    color: #003366 !important;
    display: inline-block !important;
    height: 100% !important;
    text-align: center !important;
}
import './App.css';
import { PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, Annotation, TextSearch, FormFields, FormDesigner, PageOrganizer, Inject } from '@syncfusion/ej2-react-pdfviewer';

export function App() {
    return (
        <div className='control-section e-custom-style'>
            <PdfViewerComponent
                id="container"
                documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                resourceUrl="https://cdn.syncfusion.com/ej2/32.2.5/dist/ej2-pdfviewer-lib"
                style={{ 'height': '100%' }} >
                <Inject services={[Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, FormDesigner, PageOrganizer]} />
            </PdfViewerComponent>
        </div>
    );
}

Viewer background and signature fields example

Explanation

This section explains the rationale behind the recommendations and common pitfalls:

  • Use a scoped wrapper class (for example .e-custom-style) to avoid fragile, global overrides that can break when internal selectors change.
  • Load order is important: theme CSS provides base variables and components’ base rules; custom overrides must load after theme CSS to take effect reliably.
  • Prefer toggling theme files or a small root class rather than deep selector overrides when implementing dark mode — this makes switching simpler and reduces maintenance.
  • Avoid overusing !important; reserve it for third-party widgets or unavoidable form-field styling where the library applies strong specificity.
  • Always verify color-contrast and keyboard focus styles after applying themes or overrides to preserve accessibility.

Reference